
function compute_segmentations()

  
  
  index = dataset_definition();
  
  mkdir data/segmentation;
  mkdir data/masks;
  
  
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % compute segmentation
  
  
  if 1
    
    fprintf('***** Computing segmentation\n');

    % prepare parameters for multiprocessing execution
    params = {};
    for imi = 1 : length(index.imnames)      
      params{imi} = {index, imi}; 
    end

    startmulticoremaster(@compute_segmentation_1, params);
    
  end
  
  
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %%%% extract candidate boxes 
 
  if 1
    fprintf('**** Finding candiate boxes\n');  
    
    int16max = intmax('int16');
    assert(max(index.imsizes(:))<=int16max); % if this fails (very unlikely), that that we means images are way too big! :)
    
    % prepare parameters for multiprocessing execution
    params = {};
    for imi = 1 : length(index.imnames)
      imname = index.imnames{imi};  
      seg_filename = [ 'data/segmentation/' imname '.mat'];
      masks_filename = ['data/masks/' imname '.mat'];    
      params{imi} = {index.imsizes(imi, :), seg_filename, masks_filename, imi};
    end
    
    out = startmulticoremaster(@segments_to_masks, params);  
    
    boxes = [out{:}];  
    save('data/masks/bbs.mat', 'boxes'); 
   
  end

end



function compute_segmentation_1(index, imno)

  imname = index.imnames{imno};  
  img_filename = [index.imgroot imname '.jpg'];  
  seg_filename = [ 'data/segmentation/' imname '.mat'];
  fprintf('  image %s -> %s\n', img_filename, seg_filename);  
  im = imread(img_filename); 
  trees = selective_search_segmentation(im);  
  save(seg_filename,'-v7','trees');    

end

