
function index = dataset_definition()
  
    
    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% define input images + bboxes

index = struct(); 
% adjust path here 
index.imgroot = 'voc07_data/JPEGImages/';
index.imnames = {'000016'  '000023'  '000030'  '000032'  '000033'  '000117'  '000129'  '000228'  '000268'  '000480'};
index.clsnames = {'aeroplane'  'bicycle'};
index.viewnames = {''  'Frontal'  'Left'  'Rear'  'Right'};

% height width
index.imsizes = [
   500   334
   500   334
   375   500
   281   500
   366   500
   333   500
   500   334
   333   500
   333   500
   375   500
];


index.all_trainmask = logical([0 1 0 1 1 0 1 1 0 0]);
index.all_testmask = logical([1 0 1 0 0 1 0 0 1 1]);


% format of ground-truth annotations: 
%   |image no                            |difficult?
%         |xmin |ymin |xmax |ymax              |truncated?
%                                  |class index      |view index 
gt_annots = [
     1    92    72   305   473     2     0     0     4
     2     9   230   245   500     2     0     1     1
     2   230   220   334   500     2     0     1     2
     2     2   178    90   500     2     1     1     1
     3    36   205   180   289     2     0     0     5
     4   104    78   375   183     1     0     0     2
     4   133    88   197   123     1     0     0     3
     5     9   107   499   263     1     0     0     1
     5   421   200   482   226     1     0     0     3
     5   325   188   411   223     1     0     1     3
     6     1    42   498   284     1     0     1     1
     7    70   202   255   500     2     0     0     1
     7   251   242   334   500     2     1     1     1
     7     1   144    67   436     2     1     1     1
     8    92    82   314   228     1     0     0     1
     9   180   103   436   281     1     0     1     1
     9     1    58   262   333     1     0     1     3
    10     2    68   486   325     1     0     1     1
]; 

for i = 1:length(index.imnames)
  lines = (gt_annots(:, 1) == i);
  index.gtboxes(i).bbs = gt_annots(lines, 2:5); 
  index.gtboxes(i).clsind = gt_annots(lines, 6); 
  index.gtboxes(i).view = gt_annots(lines, 9); 
  index.gtboxes(i).diffmask = gt_annots(lines, 7); 
end
