function done = check_state(LogL,ops,Q)

done = false;
iter = length(LogL);

if iter>1
  rel_change = (LogL(iter)-LogL(iter-1)) / abs(mean(LogL(iter-1:iter)));
else 
  rel_change = inf;
end

if rel_change < 0;
  done = true;
  fprintf('--> Log likelihood decreased in iteration %d,  relative change %f\n',iter,rel_change);
end

if (rel_change < ops.eps) && (iter > ops.mni);
  done = true;
end

if iter>=ops.mxi
  done = true;
end


if ops.dia
  fprintf('iteration %3d   Logl %.2f  relative increment  %.6f\n',iter, LogL(iter),rel_change);
  if ops.dia>1
    clf;
    set(gcf,'Double','on');
    imagesc(Q);
    xlabel('data point index');
    ylabel('mixture component index');    
    colormap gray;cm = colormap;colormap(cm(end:-1:1,:))    
    colorbar;
    title('Posterior distributions on mixture components given data point');
    drawnow;
  end
end

