// See cn_pqliblinear_mex.cpp cn_pqliblinear_testmex.cpp

/**
 * Author: R. Gokberk Cinbis.
 */


// wscr cases
class WSCR_Z_N {};
class WSCR_1_N {};
class WSCR_Z_1 {};
class WSCR_1_1 {};

enum EnumWscrCase { ENUM_WSCR_Z_N = 0, ENUM_WSCR_Z_1, ENUM_WSCR_1_N, ENUM_WSCR_1_1 };

EnumWscrCase getWscrCase(const mxArray *wscrArray,const mwSize Z,const mwSize N) {
    const mwSize wscr_d1 = cn::mex::getdim(wscrArray,1);
    const mwSize wscr_d2 = cn::mex::getdim(wscrArray,2);
    if        ((wscr_d1 == Z) && (wscr_d2 == N)) {
        return ENUM_WSCR_Z_N;
    } else if ((wscr_d1 == 1) && (wscr_d2 == N)) {
        return ENUM_WSCR_1_N;
    } else if ((wscr_d1 == Z) && (wscr_d2 == 1)) {
        return ENUM_WSCR_Z_1;
    } else if ((wscr_d1 == 1) && (wscr_d2 == 1)) {
        return ENUM_WSCR_1_1;
    } else {
        mexErrMsgTxt("wscr has to have one of the following shapes: (Z N) | (1 N) | (Z 1) | (1 1)");
        return ENUM_WSCR_1_1; // just to avoid compilation warning
    }
}


