function c = pq_assign(pq,v)
% Assigns PQ-codes to a given set of vectors.  A faster mex re-implementation of lear_matlab/pq_assign_old.m
%
% INPUT
% pq        PQ structure, prepared with pq_prep()
% v         (D N) single OR double precision data, same as pq.cent3s.
%
% OUTPUT
% c         (nsq N) uint8 PQ codes.
%
% R.G.Cinbis Jan 2012

% This function is at least 10x faster than pq_assign_org(), even though both are multithreaded. The main reason is
% that here we respect cache better, while avoiding slicing, etc. operations.

% Rarely, this will not agree with the original implementation. As far as I see, this occurs only at the cases where two
% clusters have exactly the same distance.

%{

pq = pq_new(8,single(rand(80,1000)));
pq = pq_prep(pq);

X=rand(80,500000,'single');

tic; y=pq_assign(pq,X); toc;

% cn_makeall pq_assign;
tic; y2=pq_assign(pq,X); toc;

p=find(colvec(y~=y2)); [y(p) [zeros(length(p),1)] y2(p)]

%}

error('Compile mex file via cn_makeall pq_assign');



