function pq_l2normsq(codes,l2normsq_c,z2c)
% Compute L2 norm-squared based on pq codes.
% Allows computing based on concatenation of a number of PQ centers
% and also allows re-using pq centers.
%
% INPUT
% codes             (sum(nsq_z) N)  uint8   codes where nsq_z = nsq_c(z2c). (Base 0)
% l2normsq_c        (1 C)           cell    Each one; (ks nsq_c(c)),double. Obtained via {pq.l2normsq}.
% z2c               (1 Z)           uint64  Defines sharing of PQ codes across subvector index by z. (Base 1)
%
% OUTPUT
% out               (Z N)           double  Squared-norm of each subvector. 
%                                           sqrt(sum(out,1)) gives the norm of the vector.
%
% R.G.Cinbis July 2012

error('compile mex');

