#pragma once

#include <signal.h>

/**
 * Author: R. Gokberk Cinbis.
 */


/**
 * USAGE
 *
 * Create a unique instance of siginthandler and use its state() function.
 */

namespace cn {
    
    // todo: make this class singleton
    class siginthandler {
        public: 

            siginthandler() ;

            ~siginthandler() ;

            // return true if ctrl-c was pressed.
            inline bool state() const {
                return s;
            }
            
            // handler function for internal use
            static void _fhandle(int sig) ;

        private:
            static bool s;
            sighandler_t old;
    };

}





