
/**
 * Author: R. Gokberk Cinbis.
 */



/// Do to += from.
template <class T>
void addToVector(T *from, T *to, mwSize len) {
    for (mwIndex d = 0; d < len; ++d ) {
        *(to++) += *(from++);
    }
}

/**
 * Utility function to print a matrix.
 */
template <class TT> 
void printMatrix( const uint64_t M, const uint64_t N, const TT * vals, const char *name ) {

    printf("%s: ",name);
    if (M >= 2)
        printf("\n");
    for ( uint64_t i = 0; i < M; ++i) {
        for ( uint64_t j = 0; j < N; ++j) {
            if ( std::numeric_limits<TT>::is_integer )
                printf("%2d ",(int) vals[M * j + i]);
            else
                printf("%4.2f ",(double) vals[M * j + i]);
        }
        printf("\n");
    }
    printf("\n");

}


/**
 * Utility function to convert number of string.
 */
template <class TT>
string num2str(const TT i) {
    std::stringstream ss;
    ss << i;
    return ss.str();
}


