function [pts] = cn_mappts_apply(pts,mapinfo)
% [pts] = cn_mappts_apply(pts,mapinfo)
%
% Apply the mapping on the new points.
% 
% SEE cn_mappts() cn_mappts_applytobb()
%
% R.G.Cinbis Oct 2010

if isempty(pts)
    return;
end

scale1 = mapinfo.scale1;
shift2 = mapinfo.shift2;

% For safety, don't support cell arrays.
assert(size(pts,1)==size(scale1,1));
pts = bsxfun(@plus,bsxfun(@times,pts,scale1),shift2);

